/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package boswarsFontes;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

/**
 *
 * @author Rodrigo
 */
public class DataHandler {

    /**
     * Units Database
     */
    public ArrayList<Unit> unitBase;
    
    /**
     * Buildings Database
     */
    public ArrayList<String> buildingBase;
    
    /**
     * Buildings Database Used on Mutation operator
     */
    public ArrayList<String> buildingBaseMut;
    
    /**
     * Map Name
     */
    public String mapName;
    
    /**
     * Name of the directory of the game executable
     */
    public String dir;
    
    /**
     * DataHandler Object (singleton pattern) 
     */
    private static DataHandler obj = null;
    
    /**
     * Max number of forces
     */
    public static final int MAXFORCE            = 6;
    
    public static final int MAXTYPE             = 3;
    
    /**
     * Maximum quantity of units to be requested
     */
    public static final int MAXQTDE             = 5;
    

    
    /**
     * Minimum quantity of units to be requested
     */
    public static final int MINQTDE             = 2;
    
    /**
     * Maximum game cycles
     */
    public static final int MAXCYCLES           = 150000;
    
    /**
     * Maximum quantity of genes to be mutated
     */
    public static final int MAXGENES            = 8;

    /**
     * Army Gene code
     */
    public static final int CREATE_BATTALION    = 1;
    
    /**
     * Building Gene code
     */
    public static final int CREATE_BUILDING     = 0;
    
    /**
     * Constructor - Get data of the Evolutionary Algorithm
     */
    private DataHandler() throws FileNotFoundException {
        buildingBaseMut = new ArrayList<>();
        buildingBase    = new ArrayList<>();
        unitBase        = new ArrayList<>();

        this.readBuildingMutDB();
        this.readBuildingtDB();
        this.readUnitDB();
        this.readMapName();
        this.readDir();
    }

    /**
     * Object - returns a reference of a DataHandler object
     *
     * @return obj reference
     */
    public static DataHandler object() throws FileNotFoundException {
        if (obj == null) {
            obj = new DataHandler();
        }
        return obj;
    }

        
    /**
     * Read Buildings database .bwdb for mutation operator
     */
    private void readBuildingMutDB() throws FileNotFoundException{
        Scanner sc = new Scanner(new File("buildingsMut.bwdb"));
        while (sc.hasNextLine()) {
            this.buildingBaseMut.add(sc.nextLine());
        }
        sc.close();
    }
    
    /**
     * Read Buildings database .bwdb
     */
    private void readBuildingtDB() throws FileNotFoundException {
        Scanner sc = new Scanner(new File("buildings.bwdb"));
        while (sc.hasNextLine()) {
            this.buildingBase.add(sc.nextLine());
        }
        sc.close();
    }

    /**
     * Read Units database .bwdb
     */
    private void readUnitDB() throws FileNotFoundException {
        Scanner sc = new Scanner(new File("units.bwdb"));
        while (sc.hasNextLine()) {
            this.unitBase.add(new Unit(sc.nextLine().split(":")));
        }
        sc.close();
    }
    
    /**
     * Read Map Name
     */
    private void readMapName() throws FileNotFoundException{
         Scanner sc = new Scanner(new File("map.bwdb"));
         this.mapName = sc.nextLine();
         sc.close();
    }
    
    /**
     * Read Directory of the game
     */
    private void readDir() throws FileNotFoundException{
         Scanner sc = new Scanner(new File("dir.bwdb"));
         this.dir = sc.nextLine();
         sc.close();
    }
}
