/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package boswarsFontes;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

/**
 *
 * @author Rodrigo
 */
public class Enemy extends Individual {

    private ArrayList<String> playersList;
    
    /**
     * List of scripts that have played
     */
    public ArrayList<String> yetPlayed;

    /**
     * Constructor
     * @param pos Position of the enemy on the map
     * @throws FileNotFoundException 
     */
    public Enemy( int pos) throws FileNotFoundException {
        this.playersList = new ArrayList();
        this.yetPlayed = new ArrayList();
        this.setPos(pos);
        this.loadEnemies();
    }

    /**
     * Load enemy database
     * @throws FileNotFoundException 
     */
    public  void loadEnemies() throws FileNotFoundException {
        playersList = new ArrayList();

        Scanner sc = new Scanner(new File("enemies.bwdb"));
        while (sc.hasNextLine()) {
            this.playersList.add(sc.nextLine());
        }
        sc.close();
    }

    /**
     * Raffle an enemy
     *
     * @return True if there is at least one enemy to play, false otherwise.
     * If it is true, a new enemy is chosen to play
     */
    public  boolean raffle() {
        int index;
        if (playersList.size() == yetPlayed.size()) {
            return false;
        } else {
            do {
                index = Util.rmd.nextInt(playersList.size());
            } while (yetPlayed.contains(playersList.get(index)));
            yetPlayed.add(playersList.get(index));
            this.setName(playersList.get(index));
            
            return true;
        }

    }

    /**
     * Clear list of scripts that have already played.
     */
    public  void resetYetPlayer() {
        yetPlayed = new ArrayList();
    }
    
    /**
     * The current script is winner, so clear the resetYetPlayer and add the winner
     */
    public void won(){
        String s = yetPlayed.get(yetPlayed.size() -1 ).toString();
        this.resetYetPlayer();
        yetPlayed.add(s);
    }

    @Override
    public void prepareForBattle() throws FileNotFoundException {
        this.resetCounters();
        this.register();
    }
    
}
