/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package boswarsFontes;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;

/**
 *
 * @author Rodrigo
 */
public class MatchHandler {

    /**
     * MatchHandler Object (singleton pattern) 
     */
    private static MatchHandler obj = null;
    
    /**
     * Flag of GUI
     */
    private boolean GUI;
    
    /**
     * Flag of Automatic game
     */
    private boolean Auto;
    
    /**
     * Game speed
     */
    private int speed;

    /**
     * Constructor
     */
    private MatchHandler() throws FileNotFoundException {
        this.setAuto(true);
        this.setGUI(false);
        this.setSpeed(1000);

        /**
         * Create Battle Log File
         */
        this.createBattleLogFile();
    }

    /**
     * Object - returns a reference of a MatchHandler object
     *
     * @return obj reference
     */
    public static MatchHandler object() throws FileNotFoundException {
        if (obj == null) {
            obj = new MatchHandler();
        }
        return obj;
    }

    /**
     * Open the game to play a single match
     */
    public void callGame() throws InterruptedException, IOException {
       Process processo;        
 
        processo = Runtime.getRuntime().exec(DataHandler.object().dir+"rodrigo.exe", null, new File(DataHandler.object().dir));     
        processo.waitFor();
    }

    /**
     * Create Battle Log file
     */
    private  void createBattleLogFile() throws FileNotFoundException {
        PrintStream out = new PrintStream(new FileOutputStream(new File("battleLog.csv"), false));
        out.printf(";;; BATTLES REPORT\n\n");
        out.close();
        this.jumpLineBattleLogFile();
    }

    /**
     * Update Battle Log file
     *
     * @param ind1 Individual #1
     * @param ind2 Individual #2
     */
    public void updateBattleLogFile(Individual ind1, Individual ind2) throws FileNotFoundException {
        PrintStream out = new PrintStream(new FileOutputStream(new File("battleLog.csv"), true));
        out.printf("%d;%.5f;%.5f;;%d;%d\n",ind1.getReward(),
                    ind1.getFitness(), ind2.getFitness(), ind1.chromoOut.size(), ind1.chromoIn.size());
        out.close();
    }

    /**
     * Jump line and add header to Battle Log file
     */
    public void jumpLineBattleLogFile() throws FileNotFoundException {
        PrintStream out = new PrintStream(new FileOutputStream(new File("battleLog.csv"), true));
        out.printf("\n\n\n");
        out.printf("Reward Pop;Fitness pop;Fitness script;;#Out;#In\n");
        out.close();
    }

    /**
     * @return the GUI
     */
    public boolean isGUI() {
        return GUI;
    }

    /**
     * @param GUI the GUI to set
     */
    public final void setGUI(boolean GUI) {
        this.GUI = GUI;
    }

    /**
     * @return the Auto
     */
    public boolean isAuto() {
        return Auto;
    }

    /**
     * @param Auto the Auto to set
     */
    public final void setAuto(boolean Auto) {
        this.Auto = Auto;
    }

    /**
     * @return the speed
     */
    public int getSpeed() {
        return speed;
    }

    /**
     * @param speed the speed to set
     */
    public final void setSpeed(int speed) {
        this.speed = speed;
    }
}
